// -*- C++ -*-
/***************************************************************************
                          libmorse part of Aldo
                          ---------------------
    begin                : Sun May 6 2001
    copyleft             : Giuseppe "denever" Martino
    email                : rdmartin@infinito.it
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program; if not, write to the Free Software            *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA*
 *                                                                         *
 ***************************************************************************/

#ifndef EXERCISE_H
#define EXERCISE_H

#include "morse.h"
#include "random.h"
#include "keyer.h"
#include "skill.h"

#include <vector>
#include <fstream>

namespace libmorse
{
    class Exercise
    {
	friend std::ofstream& operator<<(std::ofstream&, const Exercise&);
	friend libkeyer::Keyer& operator<<(libkeyer::Keyer&, const Exercise&);

    private:
	std::vector<Morse_string> m_strings;
	unsigned int m_num_chars;
	unsigned int m_num_strings;    
	Skill m_skill;

	void m_prepare();
	
    public:
	Exercise(): m_num_chars(5), m_num_strings(0), m_skill(lo_medium) 
	{
	    m_strings.clear();
	}
	
	Exercise(unsigned int num, Skill s, unsigned int numch): m_num_chars(numch), m_num_strings(num), m_skill(s)
	{
	    m_prepare();
	}
	
	Exercise(const Exercise&);
    };
}
#endif //EXERCISE_H
