// -*- C++ -*-
/***************************************************************************
                          libkeyer part of Aldo
                          ---------------------
    begin                : Sun May 6 2001
    copyleft             : Giuseppe "denever" Martino
    email                : rdmartin@infinito.it
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program; if not, write to the Free Software            *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA*
 *                                                                         *
 ***************************************************************************/

#ifndef KEYER_H
#define KEYER_H

#include "astream.h"

namespace libkeyer
{
    class Keyer
    {
    private:
	libaudiostream::oastream m_audio;
	unsigned int m_count;
	unsigned int m_intrach;
	unsigned int m_interch;
	unsigned int m_interword;

    public:
	Keyer();
	Keyer(unsigned int); // Keyer(speed)
	Keyer(unsigned int, unsigned int, unsigned int); // Keyer(intrach, interch, interword)
	Keyer(unsigned int, unsigned int, unsigned int, unsigned int); // Keyer(speed, intrach, interch, interword)
	Keyer& operator<<(unsigned int);
	void char_pause();
	void string_pause();
	void pause(unsigned int);
    };
}
#endif // KEYER_H
