/***************************************************************************
                          libmorse part of Aldo
                          ---------------------
    begin                : Sun May 6 2001
    copyleft             : Giuseppe "denever" Martino
    email                : rdmartin@infinito.it
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program; if not, write to the Free Software            *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA*
 *                                                                         *
 ***************************************************************************/


#include "exercise.h"
#include <iostream>

using namespace std;
using namespace libmorse;

typedef vector<Morse_string>::const_iterator string_cit;

Exercise::Exercise(const Exercise& cpy)
{
    m_strings = cpy.m_strings;
}

void Exercise::m_prepare()
{
    char let[22];
    let[0]='e';
    let[1]='i';
    let[2]='s';
    let[3]='h';
    let[4]='t';
    let[5]='m';
    let[6]='o';// Upper Bound for beginner
    let[7]='a';
    let[8]='w';
    let[9]='j';
    let[10]='u';
    let[11]='v';// Upper Bound for Low Medium Skill
    let[12]='n';
    let[13]='d';
    let[14]='b';
    let[15]='g';// Upper Bound for High Medium Skill
    let[16]='k';
    let[17]='c';
    let[18]='y';
    let[19]='q';
    let[20]='z';
    let[21]='x';// All Letters
    
    char num[10];
    num[0]='1';
    num[1]='2';
    num[2]='3';
    num[3]='4';
    num[4]='5';
    num[5]='6';
    num[6]='7';
    num[7]='8';
    num[8]='9';
    num[9]='0';
	
    librandom::Random RND;
    m_strings.resize(m_num_strings);
    
    if(m_skill == all_letters) // Prepare strings for all letters skill
	for(unsigned int i=0; i<m_num_strings; i++)
	    for(unsigned int j=0; j<m_num_chars; j++)
		m_strings[i] += let[RND.integer(0,m_skill)];
     
    if(m_skill == numbers) // Prepare strings for only numbers skill
	for(unsigned int i=0; i<m_num_strings; i++)
	    for(unsigned int j=0; j<m_num_chars; j++)
		m_strings[i] += num[RND.integer(0,9)];
    
    
    
    if( (m_skill != all_letters) && (m_skill != numbers) )// prepare strings for others skills
	for(unsigned int i=0; i<m_num_strings; i++)
	    for(unsigned int j=0; j<m_num_chars; j++)
	    {
		char s;
		unsigned int tmpn = RND.integer(0,m_skill);
		if(tmpn>21) 
		{
		    tmpn -= 21;
		    s = num[tmpn];
		}
		else
		    s = let[tmpn];
		m_strings[i] += s;
	    }
}

libkeyer::Keyer& libmorse::operator<<(libkeyer::Keyer& out, const Exercise& exc)
{
    for(string_cit it=exc.m_strings.begin(); it!=exc.m_strings.end(); it++)
    {
	out<<*it;
    }
    return out;
}

ofstream& libmorse::operator<<(ofstream& file, const Exercise& exc)
{
    for(string_cit it=exc.m_strings.begin(); it!=exc.m_strings.end(); it++)
    {
    	file<<*it<<endl;
    }
    return file;
}
