/***************************************************************************
                           Aldo
                          --------------------
    begin                : Sun May 6 2001
    copyleft             : Giuseppe "denever" Martino
    email                : rdmartin@infinito.it
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program; if not, write to the Free Software            *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA*
 *                                                                         *
 ***************************************************************************/

#include "resources.h"

#include "menu.h"
#include "dialog.h"
#include "datafile.h"
#include "skill.h"

#include <iostream>
#include <string>
#include <cstdlib>

using namespace std;
using namespace libmenu;

Menu* tmp_menu;

void OnSpaceCh()
{
    unsigned int spacech;
    std::cout<<ask_value;
    std::cin>>spacech;

    try
    {
	std::string fileconf_name(getenv("HOME"));
	fileconf_name += "/.aldorc";

	libdatafile::Datafile fileconf(fileconf_name, libdatafile::Update);
	
	libdatafile::sec_it main_sec = fileconf.section("Main");
	
	main_sec->option("CharPause")->set(spacech);
    }
    catch(libdatafile::Not_datafile_format e)
    {
	cerr<<errmsg_noformat<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Over_write_file e)
    {
	cerr<<errmsg_overwrite<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Option_not_found e)
    {
	cerr<<errmsg_nooption<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Section_not_found e)
    {
	cerr<<errmsg_nosection<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::File_not_opened e)
    {
	cerr<<errmsg_noopenfile<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::File_not_exist e)
    {
	cerr<<errmsg_nofile<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
} 

void OnSpaceStr()
{
    unsigned int spacestr;
    std::cout<<ask_value;
    std::cin>>spacestr;

    try
    {
	std::string fileconf_name(getenv("HOME"));
	fileconf_name += "/.aldorc";

	libdatafile::Datafile fileconf(fileconf_name, libdatafile::Update);
	
	libdatafile::sec_it main_sec = fileconf.section("Main");

	main_sec->option("StringPause")->set(spacestr);
    }
    catch(libdatafile::Not_datafile_format e)
    {
	cerr<<errmsg_noformat<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Over_write_file e)
    {
	cerr<<errmsg_overwrite<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Option_not_found e)
    {
	cerr<<errmsg_nooption<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Section_not_found e)
    {
	cerr<<errmsg_nosection<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::File_not_opened e)
    {
	cerr<<errmsg_noopenfile<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::File_not_exist e)
    {
	cerr<<errmsg_nofile<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
}

void OnStrLen()
{
    unsigned int string_len;
    std::cout<<ask_value;
    std::cin>>string_len;

    try
    {
	std::string fileconf_name(getenv("HOME"));
	fileconf_name += "/.aldorc";

	libdatafile::Datafile fileconf(fileconf_name, libdatafile::Update);
	
	libdatafile::sec_it main_sec = fileconf.section("Main");
	
	main_sec->option("StringLength")->set(string_len);
    }
    catch(libdatafile::Not_datafile_format e)
    {
	cerr<<errmsg_noformat<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Over_write_file e)
    {
	cerr<<errmsg_overwrite<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Option_not_found e)
    {
	cerr<<errmsg_nooption<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Section_not_found e)
    {
	cerr<<errmsg_nosection<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::File_not_opened e)
    {
	cerr<<errmsg_noopenfile<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::File_not_exist e)
    {
	cerr<<errmsg_nofile<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
}

void OnConfQuickstart()
{
    Dialog<int> ask_speed(dlg_speed_title, main_menu_prompt);
    ask_speed.add_choice(dlg_speed_choice1,400);
    ask_speed.add_choice(dlg_speed_choice2,500);
    ask_speed.add_choice(dlg_speed_choice3,600);
    ask_speed.add_choice(dlg_speed_choice4,700);
    ask_speed.add_choice(dlg_speed_choice5,1);
    ask_speed.add_choice(dlg_speed_choice6,2);

    int speed = ask_speed.show(); // return speed in cpm

    if(speed == 1)
    {
	std::cout<<insert_cpm;
	std::cin>>speed;
	speed = speed*10;
    }

    if(speed == 2)
    {
	std::cout<<insert_wpm;
	int tmp;
	std::cin >> tmp; // read speed in wpm
	speed = 50 * tmp; // conversion from wpm to cpm 
    }

    unsigned int num_strings;
    std::cout << ask_num_of_strings;
    std::cin >> num_strings;

    Dialog<unsigned int> ask_skill(dlg_skill_title, main_menu_prompt);
    
    ask_skill.add_choice(dlg_skill_choice1,0);
    ask_skill.add_choice(dlg_skill_choice2,1);
    ask_skill.add_choice(dlg_skill_choice3,2);
    ask_skill.add_choice(dlg_skill_choice4,3);
    ask_skill.add_choice(dlg_skill_choice5,4);
    ask_skill.add_choice(dlg_skill_choice6,5);
    
    int skill = ask_skill.show();

    try
    {
	std::string fileconf_name(getenv("HOME"));
	fileconf_name += "/.aldorc";

	libdatafile::Datafile fileconf(fileconf_name, libdatafile::Update);
	
	libdatafile::sec_it quick_sec = fileconf.section("Quickstart");
	
	quick_sec->option("Speed")->set(speed);

	quick_sec->option("StringsNumber")->set(num_strings);

	quick_sec->option("Skill")->set(skill);
    }
    catch(libdatafile::Not_datafile_format e)
    {
	cerr<<errmsg_noformat<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Over_write_file e)
    {
	cerr<<errmsg_overwrite<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Option_not_found e)
    {
	cerr<<errmsg_nooption<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Section_not_found e)
    {
	cerr<<errmsg_nosection<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::File_not_opened e)
    {
	cerr<<errmsg_noopenfile<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::File_not_exist e)
    {
	cerr<<errmsg_nofile<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
} 

void OnResetDefault()
{
    std::string home(getenv("HOME"));

    try
    {
	std::string fileconf_name(getenv("HOME"));
	fileconf_name += "/.aldorc";

	libdatafile::Datafile fileconf(fileconf_name, libdatafile::Create);
	
	fileconf.add_section("Main");
	
	libdatafile::sec_it main_sec = fileconf.section("Main");

	main_sec->add_option("CharPause");

	main_sec->option("CharPause") ->set(4);
	
	main_sec->add_option("StringPause");

	main_sec->option("StringPause")->set(6);

	main_sec->add_option("StringLength");

	main_sec->option("StringLength")->set(5);
	
	main_sec->add_option("DefaultBeginPause");

	main_sec->option("DefaultBeginPause")->set(2);

	fileconf.add_section("Quickstart");

	libdatafile::sec_it quick_sec = fileconf.section("Quickstart");

	quick_sec->add_option("Speed");

	quick_sec->option("Speed")->set(400);
	
	quick_sec->add_option("StringsNumber");
	
	quick_sec->option("StringsNumber")->set(3);

	quick_sec->add_option("Skill");

	quick_sec->option("Skill")->set(0);

    }
    catch(libdatafile::Not_datafile_format e)
    {
	cerr<<errmsg_noformat<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Over_write_file e)
    {
	cerr<<errmsg_overwrite<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Option_not_found e)
    {
	cerr<<errmsg_nooption<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::Section_not_found e)
    {
	cerr<<errmsg_nosection<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::File_not_opened e)
    {
	cerr<<errmsg_noopenfile<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
    catch(libdatafile::File_not_exist e)
    {
	cerr<<errmsg_nofile<<endl;
	cerr<<errmsg_conf<<endl;
	return;
    }
}

void OnExitSetup()
{
   tmp_menu->close();
}

void OnSetup()
{

    Menu setup_menu(conf_menu_title, main_menu_prompt);

    tmp_menu = &setup_menu;
    
    const id_type spacech_id = 1;
    const id_type spacestr_id = 2;
    const id_type strlen_id = 3;
    const id_type rstdfl_id = 4;
    const id_type quikconf_id = 5;
    const id_type exit_id = 6;
    
    setup_menu.add_item(spacech_id, conf_menu_item1, OnSpaceCh);
    setup_menu.add_item(spacestr_id, conf_menu_item2, OnSpaceStr);
    setup_menu.add_item(strlen_id, conf_menu_item3, OnStrLen);
    setup_menu.add_item(quikconf_id, conf_menu_item6, OnConfQuickstart);
    setup_menu.add_item(rstdfl_id, conf_menu_item5, OnResetDefault);
    setup_menu.add_item(exit_id, conf_menu_item4, OnExitSetup);

    while( setup_menu.running() )
    	setup_menu.show();
}
